#ifndef CONNECT4_H_
#define CONNECT4_H_

#include <avr/io.h>

#define COLORS_NR 2

#define ROWS_NR 6
#define COLS_NR 7

#define RED 0
#define YEL 1
#define NA 2
#define BRED 3
#define BYEL 4

#define ROW_DELAY 1
#define BUTTON_DELAY 300

#define POS_RR0 PD7
#define POS_RR1 PD6
#define POS_RR2 PD5
#define POS_RR3 PD4
#define POS_RR4 PD1
#define POS_RR5 PD0

#define POS_YR0 PC0
#define POS_YR1 PC1
#define POS_YR2 PC2
#define POS_YR3 PC3
#define POS_YR4 PC4
#define POS_YR5 PC5

#define POS_RC0 PA0
#define POS_RC1 PA2
#define POS_RC2 PA4
#define POS_RC3 PA6
#define POS_RC4 PB0
#define POS_RC5 PB3
#define POS_RC6 PB5

#define POS_YC0 PA1
#define POS_YC1 PA3
#define POS_YC2 PA5
#define POS_YC3 PA7
#define POS_YC4 PB1
#define POS_YC5 PB4
#define POS_YC6 PB6

#define POS_DOWN PB7
#define POS_LEFT PC6
#define POS_RIGHT PC7
#define POS_UP PB2
#define POS_BUZZER PD2

#define BLINK_OFF 10
#define BLINK_ON 20

#define OFF 0
#define ON 1

#define PLACE_OP 0
#define REMOVE_OP 1

int row_pins[COLORS_NR][ROWS_NR] = {{POS_RR0, POS_RR1, POS_RR2, POS_RR3, POS_RR4, POS_RR5},
	{POS_YR0, POS_YR1, POS_YR2, POS_YR3, POS_YR4, POS_YR5}};
int col_pins[COLORS_NR][COLS_NR] = {{POS_RC0, POS_RC1, POS_RC2, POS_RC3, POS_RC4, POS_RC5, POS_RC6},
	{POS_YC0, POS_YC1, POS_YC2, POS_YC3, POS_YC4, POS_YC5, POS_YC6}};

#define PORT_RR0 PORTD
#define PORT_RR1 PORTD
#define PORT_RR2 PORTD
#define PORT_RR3 PORTD
#define PORT_RR4 PORTD
#define PORT_RR5 PORTD

#define PORT_YR0 PORTC
#define PORT_YR1 PORTC
#define PORT_YR2 PORTC
#define PORT_YR3 PORTC
#define PORT_YR4 PORTC
#define PORT_YR5 PORTC

#define PORT_RC0 PORTA
#define PORT_RC1 PORTA
#define PORT_RC2 PORTA
#define PORT_RC3 PORTA
#define PORT_RC4 PORTB
#define PORT_RC5 PORTB
#define PORT_RC6 PORTB

#define PORT_YC0 PORTA
#define PORT_YC1 PORTA
#define PORT_YC2 PORTA
#define PORT_YC3 PORTA
#define PORT_YC4 PORTB
#define PORT_YC5 PORTB
#define PORT_YC6 PORTB

#define PORT_DOWN PORTB
#define PORT_LEFT PORTC
#define PORT_RIGHT PORTC
#define PORT_UP PORTB
#define PORT_BUZZER PORTD

volatile uint8_t *row_ports[COLORS_NR][ROWS_NR] = {{&PORT_RR0, &PORT_RR1, &PORT_RR2, &PORT_RR3, &PORT_RR4, &PORT_RR5},
	{&PORT_YR0, &PORT_YR1, &PORT_YR2, &PORT_YR3, &PORT_YR4, &PORT_YR5}};
volatile uint8_t *col_ports[COLORS_NR][COLS_NR] = {{&PORT_RC0, &PORT_RC1, &PORT_RC2, &PORT_RC3, &PORT_RC4, &PORT_RC5, &PORT_RC6},
	{&PORT_YC0, &PORT_YC1, &PORT_YC2, &PORT_YC3, &PORT_YC4, &PORT_YC5, &PORT_YC6}};

#define DDR_RR0 DDRD
#define DDR_RR1 DDRD
#define DDR_RR2 DDRD
#define DDR_RR3 DDRD
#define DDR_RR4 DDRD
#define DDR_RR5 DDRD

#define DDR_YR0 DDRC
#define DDR_YR1 DDRC
#define DDR_YR2 DDRC
#define DDR_YR3 DDRC
#define DDR_YR4 DDRC
#define DDR_YR5 DDRC

#define DDR_RC0 DDRA
#define DDR_RC1 DDRA
#define DDR_RC2 DDRA
#define DDR_RC3 DDRA
#define DDR_RC4 DDRB
#define DDR_RC5 DDRB
#define DDR_RC6 DDRB

#define DDR_YC0 DDRA
#define DDR_YC1 DDRA
#define DDR_YC2 DDRA
#define DDR_YC3 DDRA
#define DDR_YC4 DDRB
#define DDR_YC5 DDRB
#define DDR_YC6 DDRB

#define DDR_DOWN DDRB
#define DDR_LEFT DDRC
#define DDR_RIGHT DDRC
#define DDR_UP DDRB
#define DDR_BUZZER DDRD

volatile uint8_t *row_ddrs[COLORS_NR][ROWS_NR] = {{&DDR_RR0, &DDR_RR1, &DDR_RR2, &DDR_RR3, &DDR_RR4, &DDR_RR5},
	{&DDR_YR0, &DDR_YR1, &DDR_YR2, &DDR_YR3, &DDR_YR4, &DDR_YR5}};
volatile uint8_t *col_ddrs[COLORS_NR][COLS_NR] = {{&DDR_RC0, &DDR_RC1, &DDR_RC2, &DDR_RC3, &DDR_RC4, &DDR_RC5, &DDR_RC6},
	{&DDR_YC0, &DDR_YC1, &DDR_YC2, &DDR_YC3, &DDR_YC4, &DDR_YC5, &DDR_YC6}};

#define PIN_DOWN PINB
#define PIN_LEFT PINC
#define PIN_RIGHT PINC
#define PIN_UP PINB
#define PIN_BUZZER PIND

#define WIN_NR 4
#define BUZZER_CNT 10

void turn_on_led(int row, int col, int color);
void turn_off_led(int row, int col, int color);
void timer1_init();
void timer1_uninit();
void timer2_init();
void timer2_uninit();
void timer3_init(int time);
void timer3_uninit();
void init();
void display_board();
int is_empty(int row, int col);
void change_turn();
void place_piece();
void win(int color);
int check_row(int row);
int check_rows();
int check_col(int col);
int check_cols();
int check_diag_right(int row, int col);
int check_diag_left(int row, int col);
int check_diags();
int game_over();
void loop();

#endif
